<template>
  <div>
    <v-skeleton-loader
      v-if="pedidoId === 0"
      type="table-heading, image"
    ></v-skeleton-loader>
    <div v-else>
      <div class="d-flex justify-space-between">
        <div style="width: 100px;">
          <v-select
            v-model="perPage"
            :label="$t('totalVisible')"
            :items="listPerPage"
            @change="getDetallePedido"
            dense
          />
        </div>
        <div class="d-flex justify-end">
          <v-btn
            class="mt-2 mr-4"
            color="primary"
            rounded
            small
            @click="refreshTable"
            :disabled="loading"
          >
            <v-icon>mdi-refresh</v-icon>
            {{ $t('actualizar') }}
          </v-btn>
          <v-pagination
            v-model="currentPage"
            :disabled="loading"
            :length="lastPage"
            :total-visible="8"
          />
        </div>
      </div>
      <v-data-table
        v-model="selected"
        :headers="headers"
        :items="detallePedodoData"
        item-key="id"
        class="elevation-1"
        disable-pagination
        hide-default-footer
        dense
        :loading="loading"
      >
        <template v-slot:item.cantidad="props">
          <v-edit-dialog
            :return-value.sync="props.item.cantidad"
            large
            persistent
            :cancel-text="$t('cancelar')"
            :save-text="$t('guardar')"
            @save="guardarCantidad(props.item.id)"
          >
            <div>{{ props.item.cantidad }}</div>
            <template v-slot:input>
              <div class="mt-4 text-h6">
                {{ $t('editarCantidad') }}
              </div>
              <v-text-field
                v-model="form.cantidad"
                :label="$t('editar')"
                single-line
                autofocus
                :rules="rules.isRequired"
                onkeyup="value=value.replace(/[^0-9^\.]+/g,'').replace(/\./g,'').replace('$#$','.').replace(/^0+/, '')"
                hide-details="auto"
              ></v-text-field>
            </template>
          </v-edit-dialog>
        </template>
        <template v-slot:item.actions="{ item }">
          <v-btn
            small
            icon
            @click="eliminarDetalle(item.id)"
          >
            <v-icon>mdi-delete</v-icon>
          </v-btn>
        </template>
      </v-data-table>
    </div>
  </div>
</template>

<script>
import DetallePedidoServicio from '@/store/services/DetallePedidoServicio'

export default {
  name: "DetallePedido",
  props: {
    pedidoId: {
      type: Number,
      required: false,
      default: 0
    }
  },
  data() {
    return {
      listPerPage: [5, 10, 15, this.$t('todo')],
      perPage: 5,
      lastPage: 0,
      total: 0,
      currentPage: 1,
      detallePedodoData: [],
      selected: [],
      loading: false,
      form: {
        cantidad: 0
      },
      rules: {
        isRequired: [value => !!value || this.$t('campoRequerido')],
      },
    }
  },
  methods: {
    verifyType(value) {
      return typeof value;
    },
    async getDetallePedido() {
      this.loading = true;
      const params = {
        page: this.currentPage,
        pedido_id: this.pedidoId,
        order_by: 'created_at',
        order_direction: 'DESC',
        per_page:
          this.verifyType(this.perPage) === 'string'
            ? this.total
            : this.perPage,
      }
      try {
        let response = await DetallePedidoServicio.index(params)
        this.detallePedodoData = response.data.data;
        this.currentPage = response.data.current_page;
        this.lastPage = response.data.last_page;
        this.total = response.data.total;
        this.loading = false;
      } catch (error) {
        this.loading = false;
        if (error.response.status !== 401) {
          console.log(error)
        }
      }
    },
    refreshTable() {
      this.resetCurrentPage();
    },
    resetCurrentPage() {
      if (this.currentPage === 1) this.getDetallePedido();
      else this.currentPage = 1;
    },
    editarMaterial(value) {
      console.log(value)
      this.$emit('onEditarMaterial', value)
    },
    async guardarCantidad(detalleId) {
      try {
        this.loading = true
        await DetallePedidoServicio.update(detalleId, this.form)
        .then(() => {
          this.refreshTable()
        })
        this.loading = false;
      } catch (error) {
        this.loading = false;
        if (error.response.status !== 401) {
          console.log(error)
        }
      }
    },
    async eliminarDetalle(detalleId) {
      try {
        this.loading = true
        await DetallePedidoServicio.remove(detalleId)
        .then(() => {
          this.refreshTable()
        })
        this.loading = false;
      } catch (error) {
        this.loading = false;
        if (error.response.status !== 401) {
          console.log(error)
        }
      }
    }
  },
  computed: {
    headers() {
      return [
        {
          value: 'actions',
          sortable: false,
        },
        {
          text: this.$t('id'),
          value: 'material.id',
          sortable: false,
        },
        {
          text: this.$t('codigo'),
          value: 'material.codigo',
          sortable: false,
        },
        {
          text: this.$t('descripcion'),
          value: 'material.descripcion',
          sortable: false,
        },
        {
          text: this.$t('cantidad'),
          value: 'cantidad',
          sortable: false,
          align: 'center'
        },
        {
          text: this.$t('marca'),
          value: 'material.marca',
          sortable: false,
        },
        {
          text: this.$t('color'),
          value: 'material.color',
          sortable: false,
        },
        {
          text: this.$t('tamanio'),
          value: 'material.tamanio',
          sortable: false,
        },
        {
          text: this.$t('unidManejo'),
          value: 'material.unid_manejo',
          sortable: false,
        },
      ];
    },
  },
  watch: {
    currentPage() {
      this.getDetallePedido()
    },
    pedidoId: {
      immediate: true,
      handler() {
        if (this.pedidoId > 0) {
          this.getDetallePedido()
        }
      }
    }
  },
  created() {
  }
}
</script>

<style>

</style>
